﻿using FCS.Common;
using FCS.Interface;
using FCS.Models;
using FCS.Models.DTO;
using FCS.Models.Entity;
using HtmlAgilityPack;
using Newtonsoft.Json.Linq;
using Quartz;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading;
using System.Threading.Tasks;

namespace FCS.Crawler.Basketball
{
    /// <summary>
    /// 篮球CBA球队抓取服务
    /// </summary>
    public class B_TeamandPlayerCBAJob : CommonJob, IJob
    {
        
        private string Teamurl="http://nba.nowscore.com/jsData/teamInfo/ti5.js";
        private string TeamDetailurl = "http://nba.nowscore.com/jsData/teamInfo/teamDetail/td{0}.js?version=2018111310";
        private string playerDetailurl = "http://nba.nowscore.com/cn/Team/player.aspx?playerid={0}";
        private string TeamListurl1 = "http://nba.nowscore.com/jsData/teamTech/{0}/th5_3.js?version=2018111409";//季前赛
        private string TeamListurl2 = "http://nba.nowscore.com/jsData/teamTech/{0}/th5_1.js?version=2018111409";//常规赛
        private string TeamListurl3 = "http://nba.nowscore.com/jsData/teamTech/{0}/th5_2.js?version=2018111409";//季后赛
        public static string BasketballGameType1 = "46e45307e4c2e811ad24107b444734db";//季前赛
        public static string BasketballGameType2 = "47e45307e4c2e811ad24107b444734db";//常规赛
        public static string BasketballGameType3 = "5ec47410e4c2e811ad24107b444734db";//季后赛
        private static string eventId="";
        public static int num=0;
        B_Team g;
        public B_TeamandPlayerCBAJob()
        {
            log = new LogHelper();
            services = IOC.Resolve<IDTOpenCode>();
            g = new B_Team();
        }
        public void Execute(IJobExecutionContext context)
        {
            //Config = CommonHelper.GetConfigFromDataMap(context.JobDetail.JobDataMap);
            //GetAll();
        }
        //http://nba.nowscore.com/cn/TeamInfo.aspx?SclassID=5 球队原文链接
        //更新服务
        public void Click()
        {
            CommonHelper.LogBD(typeof(B_TeamandPlayerCBAJob), () =>
            {
                eventId = new B_EventsJob().GetEventList().Where(p => p.Name == ConfigurationManager.AppSettings["CBAEventName"]).ToList()[0].Id;
                var AllTeamList = services.Query<B_Team>((" and EventId='{0}' and Remark is not null").FormatMe(eventId)).ToList();
                var AllPlayermList = services.Query<B_Players>().ToList();
                //获取分组存取的url ds.Tables[0].Rows.Count

                var teamlist_new = GetTeamHtml(Teamurl);
                Trace.WriteLine("获取B_Team 完结 数目：" + teamlist_new.Length);
                int max = teamlist_new.Length;
                int num = 0;
                var ss = teamlist_new.ToList();
                List<B_Players> PlayerList = new List<B_Players>();
                List<B_Team> teamlist = new List<B_Team>();
                for (int i = 0; i < teamlist_new.Length; i++)
                {
                    var teamorplayer = GetPlayersHtml(teamlist_new[i]);
                    if (teamorplayer.team != null)
                        teamlist.Add(teamorplayer.team);
                    if (teamorplayer.playerlist.Count > 0)
                        PlayerList.AddRange(teamorplayer.playerlist);
                }
                List<B_Team> teamlistnew = new List<B_Team>();
                List<string> listid = new List<string>();
                if (teamlist != null)
                {
                    foreach (var item in teamlist)
                    {
                        var team = AllTeamList.Where(a => a.Name == item.Name).ToList();
                        if (team.Count == 0)
                        {
                            teamlistnew.Add(item);
                        }
                        else if (team.Count > 1)
                        {
                            foreach (var item1 in team)
                            {
                                listid.Add(item1.Id);
                            }
                            teamlistnew.Add(item);
                        }
                    }
                    if (teamlistnew.Count > 0)
                        services.SqlBulkCopyAdd<B_Team>(teamlistnew);
                    Trace.WriteLine("插入B_Team 完结 数目：" + teamlistnew.Count);
                    if (listid.Count > 0)
                        services.Delete<B_Team>(" and Id in (" + string.Join("','", listid) + ")");
                    Trace.WriteLine("删除 B_Team 数目：" + teamlistnew.Count);
                }
                AllTeamList = services.Query<B_Team>((" and EventId='{0}' and Remark is not null").FormatMe(eventId)).ToList();
                listid = new List<string>();
                List<B_Players> PlayerListnew = new List<B_Players>();
                if (PlayerList != null)
                {
                    foreach (var item in AllTeamList)
                    {
                        var player = AllPlayermList.Where(a => a.TeamId == item.Id).ToList();
                        var playernew = PlayerList.Where(a => a.TeamId == item.Name).ToList();
                        foreach (var item1 in playernew)
                        {
                            var player_model = player.Where(a => a.ChineseName == item1.ChineseName).ToList();
                            if (player_model.Count == 0)
                            {
                                item1.TeamId = item.Id;
                                PlayerListnew.Add(item1);
                            }
                            else if (player_model.Count > 1)
                            {
                                foreach (var item2 in player_model)
                                {
                                    listid.Add(item1.Id);
                                }
                                item1.TeamId = item.Id;
                                PlayerListnew.Add(item1);
                            }
                        }

                    }
                    if (PlayerListnew.Count > 0)
                        services.SqlBulkCopyAdd<B_Players>(PlayerListnew);
                    Trace.WriteLine("插入B_Players 完结 数目：" + PlayerListnew.Count);
                    if (listid.Count > 0)
                        services.Delete<B_Players>(" and Id in ('" + string.Join("','", listid) + "')");
                    Trace.WriteLine("删除 B_Players 数目：" + listid.Count);
                }

                //球队统计
                var ds = services.Query<B_Grouping>((" and EventId='{0}' and Season like '%{1}%' group by Season").FormatMe(eventId, DateTime.Now.Year), "", " a.Season ").ToList();
                var hisstalist = services.Query<B_TeamStatistics>((" and EventId='{0}' and Season like '%{1}%' ").FormatMe(eventId, DateTime.Now.Year));
                List<B_TeamStatistics> stalist = new List<B_TeamStatistics>();
                foreach (var item in ds)
                {
                    string urlsea = item.Season.Replace("20", "");
                    var TeamTechList1 = GetTeamList(TeamListurl1.FormatMe(urlsea));
                    if (TeamTechList1.Count == 2 && TeamTechList1[0] != null && TeamTechList1[1] != null)
                    {
                        var Tech = TeamTechList1[1];
                        var team = TeamTechList1[0];
                        for (int i = 0; i < Tech.Length; i++)
                        {
                            B_TeamStatistics sta = new B_TeamStatistics();
                            sta.AvgAssists = Tech[i][8];
                            sta.AvgBasketball = Tech[i][7];
                            sta.AvgBlocks = Tech[i][9];
                            sta.AvgFoul = Tech[i][12];
                            sta.AvgMiss = Tech[i][11];
                            sta.AvgSteals = Tech[i][10];
                            sta.CreateDateTime = DateTime.Now;
                            sta.EventId = eventId;
                            sta.GameType = BasketballGameType1;
                            sta.Id = CommonHelper.GetGuid();
                            sta.LossAvg = Tech[i][3];
                            sta.PenaltyKickHitRate = Tech[i][6];
                            sta.Remark = "";
                            sta.ScoreAvg = Tech[i][2];
                            sta.Season = item.Season;
                            sta.ShootingHitRate = Tech[i][4];
                            sta.Sort = 0;
                            sta.Sum = Tech[i][1].TryToInt32();
                            var teamname = team.Where(A => A[0] == Tech[i][0]).ToList();
                            sta.TeamId = teamname[0] == null ? "" : teamname[0][1];
                            sta.TrisectionHitRate = Tech[i][5];
                            stalist.Add(sta);
                        }
                    }
                    var TeamTechList2 = GetTeamList(TeamListurl2.FormatMe(urlsea));
                    if (TeamTechList2.Count == 2 && TeamTechList2[0] != null && TeamTechList2[1] != null)
                    {
                        var Tech = TeamTechList2[1];
                        var team = TeamTechList2[0];
                        for (int i = 0; i < Tech.Length; i++)
                        {
                            B_TeamStatistics sta = new B_TeamStatistics();
                            sta.AvgAssists = Tech[i][8];
                            sta.AvgBasketball = Tech[i][7];
                            sta.AvgBlocks = Tech[i][9];
                            sta.AvgFoul = Tech[i][12];
                            sta.AvgMiss = Tech[i][11];
                            sta.AvgSteals = Tech[i][10];
                            sta.CreateDateTime = DateTime.Now;
                            sta.EventId = eventId;
                            sta.GameType = BasketballGameType2;
                            sta.Id = CommonHelper.GetGuid();
                            sta.LossAvg = Tech[i][3];
                            sta.PenaltyKickHitRate = Tech[i][6];
                            sta.Remark = "";
                            sta.ScoreAvg = Tech[i][2];
                            sta.Season = item.Season;
                            sta.ShootingHitRate = Tech[i][4];
                            sta.Sort = 0;
                            sta.Sum = Tech[i][1].TryToInt32();
                            var teamname = team.Where(A => A[0] == Tech[i][0]).ToList();
                            sta.TeamId = teamname[0] == null ? "" : teamname[0][1];
                            sta.TrisectionHitRate = Tech[i][5];
                            stalist.Add(sta);
                        }
                    }
                    var TeamTechList3 = GetTeamList(TeamListurl3.FormatMe(urlsea));
                    if (TeamTechList3.Count == 2 && TeamTechList3[0] != null && TeamTechList3[1] != null)
                    {
                        var Tech = TeamTechList3[1];
                        var team = TeamTechList3[0];
                        for (int i = 0; i < Tech.Length; i++)
                        {
                            B_TeamStatistics sta = new B_TeamStatistics();
                            sta.AvgAssists = Tech[i][8];
                            sta.AvgBasketball = Tech[i][7];
                            sta.AvgBlocks = Tech[i][9];
                            sta.AvgFoul = Tech[i][12];
                            sta.AvgMiss = Tech[i][11];
                            sta.AvgSteals = Tech[i][10];
                            sta.CreateDateTime = DateTime.Now;
                            sta.EventId = eventId;
                            sta.GameType = BasketballGameType3;
                            sta.Id = CommonHelper.GetGuid();
                            sta.LossAvg = Tech[i][3];
                            sta.PenaltyKickHitRate = Tech[i][6];
                            sta.Remark = "";
                            sta.ScoreAvg = Tech[i][2];
                            sta.Season = item.Season;
                            sta.ShootingHitRate = Tech[i][4];
                            sta.Sort = 0;
                            sta.Sum = Tech[i][1].TryToInt32();
                            var teamname = team.Where(A => A[0] == Tech[i][0]).ToList();
                            sta.TeamId = teamname[0] == null ? "" : teamname[0][1];
                            sta.TrisectionHitRate = Tech[i][5];
                            stalist.Add(sta);
                        }
                    }
                }
                List<B_TeamStatistics> stalistnew = new List<B_TeamStatistics>();
                foreach (var item in stalist)
                {
                    var team = AllTeamList.Where(a => a.Name == item.TeamId).ToList();
                    if (team.Count > 0)
                    {
                        item.TeamId = team.FirstOrDefault().Id;
                        stalistnew.Add(item);
                    }
                }
                listid = new List<string>();
                List<B_TeamStatistics> stalist_add = new List<B_TeamStatistics>();
                foreach (var item in stalistnew)
                {
                    var his_sta = hisstalist.Where(a => a.TeamId == item.TeamId && a.Season == item.Season && a.GameType == item.GameType).ToList();
                    if (his_sta.Count == 0)
                    {
                        stalist_add.Add(item);
                    }
                    else if (his_sta.Count == 1)
                    {
                        if (his_sta[0].Sum < item.Sum)
                        {
                            item.Id = his_sta[0].Id;
                            stalist_add.Add(item);
                            listid.Add(his_sta[0].Id);
                        }
                    }
                    else
                    {
                        item.Id = his_sta.Last().Id;
                        stalist_add.Add(item);
                        foreach (var item1 in his_sta)
                        {
                            listid.Add(item1.Id);
                        }
                    }
                }
                if (stalist_add.Count > 0)
                    services.SqlBulkCopyAdd<B_TeamStatistics>(stalist_add);
                Trace.WriteLine("插入 B_TeamStatistics 完结 数目：" + stalist_add.Count);

                if (listid.Count > 0)
                    services.Delete<B_TeamStatistics>(" and Id in ('" + string.Join("','", listid) + "')");
                Trace.WriteLine("删除 B_TeamStatistics 数目：" + listid.Count);
            });
          

        }
        //更新服务
        public string Click_add(string teamid)
        {
            eventId = new B_EventsJob().GetEventList().Where(p => p.Name == ConfigurationManager.AppSettings["CBAEventName"]).ToList()[0].Id;
            var AllTeamList = services.Query<B_Team>((" and EventId='{0}' and Remark is not null").FormatMe(eventId)).ToList();
            var AllPlayermList = services.Query<B_Players>().ToList();
            //获取分组存取的url ds.Tables[0].Rows.Count

            List<B_Players> PlayerList = new List<B_Players>();
            List<B_Team> teamlist = new List<B_Team>();
            
            var teamorplayer = GetteamHtml_add(teamid);
            if (teamorplayer.team != null)
                teamlist.Add(teamorplayer.team);
            if (teamorplayer.playerlist.Count > 0)
                PlayerList.AddRange(teamorplayer.playerlist);
            
            List<B_Team> teamlistnew = new List<B_Team>();
            List<string> listid = new List<string>();
            if (teamlist != null)
            {
                foreach (var item in teamlist)
                {
                    var team = AllTeamList.Where(a => a.Name == item.Name).ToList();
                    if (team.Count == 0)
                    {
                        teamlistnew.Add(item);
                    }
                    else if (team.Count > 1)
                    {
                        foreach (var item1 in team)
                        {
                            listid.Add(item1.Id);
                        }
                        teamlistnew.Add(item);
                    }
                }
                if (teamlistnew.Count > 0)
                    services.SqlBulkCopyAdd<B_Team>(teamlistnew);
                Trace.WriteLine("插入B_Team 完结 数目：" + teamlistnew.Count);
                if (listid.Count > 0)
                    services.Delete<B_Team>(" and Id in (" + string.Join("','", listid) + ")");
                Trace.WriteLine("删除 B_Team 数目：" + teamlistnew.Count);
            }
            AllTeamList = services.Query<B_Team>((" and EventId='{0}' and Remark is not null").FormatMe(eventId)).ToList();
            listid = new List<string>();
            List<B_Players> PlayerListnew = new List<B_Players>();
            if (PlayerList != null)
            {
                foreach (var item in AllTeamList)
                {
                    var player = AllPlayermList.Where(a => a.TeamId == item.Id).ToList();
                    var playernew = PlayerList.Where(a => a.TeamId == item.Name).ToList();
                    foreach (var item1 in playernew)
                    {
                        var player_model = player.Where(a => a.ChineseName == item1.ChineseName).ToList();
                        if (player_model.Count == 0)
                        {
                            item1.TeamId = item.Id;
                            PlayerListnew.Add(item1);
                        }
                        else if (player_model.Count > 1)
                        {
                            foreach (var item2 in player_model)
                            {
                                listid.Add(item1.Id);
                            }
                            item1.TeamId = item.Id;
                            PlayerListnew.Add(item1);
                        }
                    }

                }
                if (PlayerListnew.Count > 0)
                    services.SqlBulkCopyAdd<B_Players>(PlayerListnew);
                Trace.WriteLine("插入B_Players 完结 数目：" + PlayerListnew.Count);
                if (listid.Count > 0)
                    services.Delete<B_Players>(" and Id in ('" + string.Join("','", listid) + "')");
                Trace.WriteLine("删除 B_Players 数目：" + listid.Count);
            }
            return teamlist.FirstOrDefault() == null ? "" : teamlist.FirstOrDefault().Id;

        }
        //获取全部
        public void GetAll()
        {

          
            eventId = new B_EventsJob().GetEventList().Where(p => p.Name == ConfigurationManager.AppSettings["CBAEventName"]).ToList()[0].Id;
            var ds = services.Query<B_Grouping>((" and EventId='{0}' and Remark is not null group by Season").FormatMe(eventId), "", " a.Season ").ToList();
            var AllTeamList = services.Query<B_Team>((" and EventId='{0}' and Remark is not null").FormatMe(eventId)).ToList();
            //获取分组存取的url ds.Tables[0].Rows.Count

            var teamlist_new = GetTeamHtml(Teamurl);
            Trace.WriteLine("获取B_Team 完结 数目：" + teamlist_new.Length);
            List<B_Players> PlayerList = new List<B_Players>();
            List<B_Team> teamlist = new List<B_Team>();
            for (int i = 0; i < teamlist_new.Length; i++)
            {
                var teamorplayer = GetPlayersHtml(teamlist_new[i]);
                if (teamorplayer.team != null)
                    teamlist.Add(teamorplayer.team);
                if (teamorplayer.playerlist.Count > 0)
                {
                    foreach (var item in teamorplayer.playerlist)
                    {
                        item.TeamId = teamorplayer.team.Id;
                        PlayerList.Add(item);
                    }

                }

            }
            if (teamlist != null)
                services.SqlBulkCopyAdd<B_Team>(teamlist);
            Trace.WriteLine("插入B_Team 完结 数目：" + teamlist.Count);
            if (PlayerList != null)
                services.SqlBulkCopyAdd<B_Players>(PlayerList);
            Trace.WriteLine("插入B_Players 完结 数目：" + PlayerList.Count);

            //球队统计
            AllTeamList = services.Query<B_Team>((" and EventId='{0}' and Remark is not null").FormatMe(eventId)).ToList();
            List<B_TeamStatistics> stalist = new List<B_TeamStatistics>();
            
            foreach (var item in ds)
            {
                string urlsea = item.Season.Replace("20", "");
                var TeamTechList1 = GetTeamList(TeamListurl1.FormatMe(urlsea));
                if (TeamTechList1.Count == 2 && TeamTechList1[0] != null && TeamTechList1[1] != null)
                {
                    var Tech = TeamTechList1[1];
                    var team = TeamTechList1[0];
                    for (int i = 0; i < Tech.Length; i++)
                    {
                        B_TeamStatistics sta = new B_TeamStatistics();
                        sta.AvgAssists = Tech[i][8];
                        sta.AvgBasketball = Tech[i][7];
                        sta.AvgBlocks = Tech[i][9];
                        sta.AvgFoul = Tech[i][12];
                        sta.AvgMiss = Tech[i][11];
                        sta.AvgSteals = Tech[i][10];
                        sta.CreateDateTime = DateTime.Now;
                        sta.EventId = eventId;
                        sta.GameType = BasketballGameType1;
                        sta.Id = CommonHelper.GetGuid();
                        sta.LossAvg = Tech[i][3];
                        sta.PenaltyKickHitRate = Tech[i][6];
                        sta.Remark = "";
                        sta.ScoreAvg =Tech[i][2];
                        sta.Season = item.Season;
                        sta.ShootingHitRate = Tech[i][4];
                        sta.Sort = 0;
                        sta.Sum = Tech[i][1].TryToInt32();
                        var teamname = team.Where(A => A[0] == Tech[i][0]).ToList();
                        sta.TeamId = teamname[0] == null ? "":teamname[0][1] ;
                        sta.TrisectionHitRate = Tech[i][5];
                        stalist.Add(sta);
                    }
                }
                var TeamTechList2 = GetTeamList(TeamListurl2.FormatMe(urlsea));
                if (TeamTechList2.Count == 2 && TeamTechList2[0] != null && TeamTechList2[1] != null)
                {
                    var Tech = TeamTechList2[1];
                    var team = TeamTechList2[0];
                    for (int i = 0; i < Tech.Length; i++)
                    {
                        B_TeamStatistics sta = new B_TeamStatistics();
                        sta.AvgAssists = Tech[i][8];
                        sta.AvgBasketball = Tech[i][7];
                        sta.AvgBlocks = Tech[i][9];
                        sta.AvgFoul = Tech[i][12];
                        sta.AvgMiss = Tech[i][11];
                        sta.AvgSteals = Tech[i][10];
                        sta.CreateDateTime = DateTime.Now;
                        sta.EventId = eventId;
                        sta.GameType = BasketballGameType2;
                        sta.Id = CommonHelper.GetGuid();
                        sta.LossAvg = Tech[i][3];
                        sta.PenaltyKickHitRate = Tech[i][6];
                        sta.Remark = "";
                        sta.ScoreAvg = Tech[i][2];
                        sta.Season = item.Season;
                        sta.ShootingHitRate = Tech[i][4];
                        sta.Sort = 0;
                        sta.Sum = Tech[i][1].TryToInt32();
                        var teamname = team.Where(A => A[0] == Tech[i][0]).ToList();
                        sta.TeamId = teamname[0] == null ? "" : teamname[0][1];
                        sta.TrisectionHitRate = Tech[i][5];
                        stalist.Add(sta);
                    }
                }
                var TeamTechList3 = GetTeamList(TeamListurl3.FormatMe(urlsea));
                if (TeamTechList3.Count == 2 && TeamTechList3[0] != null && TeamTechList3[1] != null)
                {
                    var Tech = TeamTechList3[1];
                    var team = TeamTechList3[0];
                    for (int i = 0; i < Tech.Length; i++)
                    {
                        B_TeamStatistics sta = new B_TeamStatistics();
                        sta.AvgAssists = Tech[i][8];
                        sta.AvgBasketball = Tech[i][7];
                        sta.AvgBlocks = Tech[i][9];
                        sta.AvgFoul = Tech[i][12];
                        sta.AvgMiss = Tech[i][11];
                        sta.AvgSteals = Tech[i][10];
                        sta.CreateDateTime = DateTime.Now;
                        sta.EventId = eventId;
                        sta.GameType = BasketballGameType3;
                        sta.Id = CommonHelper.GetGuid();
                        sta.LossAvg = Tech[i][3];
                        sta.PenaltyKickHitRate = Tech[i][6];
                        sta.Remark = "";
                        sta.ScoreAvg = Tech[i][2];
                        sta.Season = item.Season;
                        sta.ShootingHitRate = Tech[i][4];
                        sta.Sort = 0;
                        sta.Sum = Tech[i][1].TryToInt32();
                        var teamname = team.Where(A => A[0] == Tech[i][0]).ToList();
                        sta.TeamId = teamname[0] == null ? "" : teamname[0][1];
                        sta.TrisectionHitRate = Tech[i][5];
                        stalist.Add(sta);
                    }
                }
            }
            List<B_TeamStatistics> stalistnew = new List<B_TeamStatistics>();
            foreach (var item in stalist)
            {
                var team=AllTeamList.Where(a => a.Name == item.TeamId).ToList();
                if (team.Count > 0)
                {
                    item.TeamId = team.FirstOrDefault().Id;
                    stalistnew.Add(item);
                }
            }
            if (stalistnew.Count>0)
                services.SqlBulkCopyAdd<B_TeamStatistics>(stalistnew);
            Trace.WriteLine("插入 B_TeamStatistics 完结 数目：" + stalistnew.Count);
        }

        /// <summary>
        /// 球队信息
        /// </summary>
        /// <param name="url"></param>
        /// <returns></returns>
        public string[][] GetTeamHtml(string url)
        {
            var html = CommonHelper.GetHtmlString_jb(url, "",1000*100);
            if (html.Contains("操作太频繁了，请先歇一歇"))
                Trace.WriteLine("球队队员信息：" + html);
            if (html.IsEmpty())
                return null;
            Regex r = new Regex(@"var arrTeam = (\w|\W)*?]];");
            // Regex r = new Regex("(class=\"dataListCountryIcon\"> )+"); //查找"Abc"Matches besget.com/country/s/114.png" 
            var teamjson = r.Match(html); //设定要查找的字符串
            string teamlistjson = "";
            if (teamjson != null)
                teamlistjson = teamjson.Value.Replace("var arrTeam = ", "").Replace("]];", "]]");
            var obj = teamlistjson.JsonToEntity<string[][]>();
            return obj;
        }
        /// <summary>
        /// 球队队员信息
        /// </summary>
        /// <param name="url"></param>
        /// <returns></returns>
        public teamorplayer GetPlayersHtml(string[] data)
        {
            teamorplayer detail = new teamorplayer();
            var html = CommonHelper.GetHtmlString_jb(TeamDetailurl.FormatMe(data[0]), "", 1000 * 100);
            if (html.Contains("操作太频繁了，请先歇一歇"))
                Trace.WriteLine("球队队员信息：" + html);
            if (html.IsEmpty())
                return detail;
            Regex r = new Regex(@"var teamSummary =(\w|\W)*?];");
            var teamjson = r.Match(html); //设定要查找的字符串
            string teamlistjson = "";
            if (teamjson != null)
                teamlistjson = "["+teamjson.Value.Replace("var teamSummary =[", "").Replace("];","").Replace("[", "\"").Replace("]", "\"")+"]";
            var obj = teamlistjson.JsonToEntity<string[]>();
            if (obj != null)
            {
                B_Team team = new B_Team();
                team.City = obj[11];
                team.Coach = ("["+obj[19]+"]").JsonToEntity<string[]>()[2];
                team.CreateDateTime = DateTime.Now;
                team.Describe = obj[16];
                team.EventId = eventId;
                team.Id = CommonHelper.GetGuid().ToString();
                team.LogoImage = "http://nba.nowscore.com" + obj[9];
                team.Name = obj[1];
                team.Remark = TeamDetailurl.FormatMe(obj[0]);
                team.Venues = obj[12];
                team.Year = obj[14];
                detail.team = team;
            }
            //球员id 集合
            r = new Regex(@"var teamPlayers = (\w|\W)*?];");
            var playerjson = r.Match(html); //设定要查找的字符串
            string playerlistjson = "";
            if (playerjson != null)
                playerlistjson = playerjson.Value.Replace("var teamPlayers = [", ",").Replace("];", "");
            //球员id 集合
            r = new Regex(@",\[(\w|\W)*?]]");
            var playerlist = r.Matches(playerlistjson);
            num += playerlist.Count;
            foreach (Match item in playerlist)
            {
                var jsonstring =("["+ item.Value.TrimStart(',','[').Replace("]]","]").Replace("[", "\"").Replace("]", "\"") + "]").JsonToEntity<string[]>();
                //球员
                //Thread.Sleep(2000);
                html = CommonHelper.GetHtmlString_jb(playerDetailurl.FormatMe(jsonstring[0]), "", 1000 * 100);
                if(html.Contains("操作太频繁了，请先歇一歇"))
                    Trace.WriteLine("球队数据：" + html);
                if (html.IsEmpty())
                    return detail;
                HtmlDocument doc = new HtmlDocument();
                doc.LoadHtml(html);
                HtmlNodeCollection playerHtml = doc.DocumentNode.SelectNodes("//*[@id='Table1']//tr");
                if (playerHtml == null)
                    return detail;
                int i = 0; 
                B_Players player = new B_Players();
                player.Id = CommonHelper.GetGuid().ToString();
                player.Birthday = "";
                player.EnglishName = "";
                HtmlNodeCollection Honor = doc.DocumentNode.SelectNodes("//*[@id='honorTable']/table//tr");
                if (Honor != null)
                {
                    if (Honor.Count > 1)
                    {
                        player.Honor = "";
                    }
                }
                player.Nationality = "";
                player.NBAVeteran = "";
                player.Number = "";
                player.Position = "";
                player.Remark = "1";
                player.TeamId = detail.team.Name;
                player.Weight = "";
                player.CreateDateTime = DateTime.Now;
                HtmlNodeCollection Describe = doc.DocumentNode.SelectNodes("//*[@id='introduce']");
                if (Describe != null)
                    player.Describe = Describe[0].InnerHtml.Trim();
                foreach (var item1 in playerHtml)
                {
                    HtmlDocument doc_2 = new HtmlDocument();
                    doc_2.LoadHtml(item1.InnerHtml);
                    HtmlNodeCollection playerdetailtdHtml = doc_2.DocumentNode.SelectNodes("//td");
                    if (playerdetailtdHtml.Count == 5 && i == 0)
                    {
                        string src = playerdetailtdHtml[0].SelectNodes("//img")[0].Attributes["src"].Value.Trim();
                        if (!src.IsEmpty())
                            player.LogoImage = src;
                        player.ChineseName = playerdetailtdHtml[2].InnerText.Trim();
                        player.Stature = playerdetailtdHtml[4].InnerText.Trim();
                    }
                    if (i == 1)
                    {
                       // player.ChineseName = playerdetailtdHtml[1].InnerText.Trim();
                        player.Weight = playerdetailtdHtml[3].InnerText.Trim();
                    }
                    if (i == 2)
                    {
                        player.EnglishName = playerdetailtdHtml[1].InnerText.Trim();
                        player.NBAVeteran = playerdetailtdHtml[3].InnerText.Trim();
                    }
                    if (i == 3)
                    {
                        player.Birthday = playerdetailtdHtml[1].InnerText.Trim();
                        //player.Stature = playerdetailtdHtml[3].InnerText.Trim();
                    }
                    if (i == 4)
                    {
                        player.Position = playerdetailtdHtml[1].InnerText.Trim();
                        //player.Stature = playerdetailtdHtml[3].InnerText.Trim();
                    }
                    if (i == 5)
                    {
                        player.Nationality = playerdetailtdHtml[1].InnerText.Trim();
                        

                    }
                    i++;
                }
                detail.playerlist.Add(player);
            }

            return detail;
        }
        /// <summary>
        /// 球队统计信息
        /// </summary>
        /// <param name="url"></param>
        /// <returns></returns>
        public List<string[][]> GetTeamList(string url)
        {
           //Thread.Sleep(2000);
            List<string[][]> list = new List<string[][]>();
            //季后赛
            var html = CommonHelper.GetHtmlString_jb(url, "", 1000 * 100);
            if (html.Contains("操作太频繁了，请先歇一歇"))
                Trace.WriteLine("球队统计信息：" + html);
            if (html.IsEmpty())
                return null;
            Regex r = new Regex(@"var arrTeam = (\w|\W)*?]];");
            var teamjson = r.Match(html); //设定要查找的字符串
            string teamlistjson = "";
            if (teamjson != null)
                teamlistjson = teamjson.Value.Replace("var arrTeam = ", "").Replace("]];", "]]");
            var teamlist = teamlistjson.JsonToEntity<string[][]>();
            list.Add(teamlist);
            r = new Regex(@"var arrTeamTech = (\w|\W)*?]];");
            var TeamTech = r.Match(html); //设定要查找的字符串
            string TeamTechjson = "";
            if (TeamTech != null)
                TeamTechjson = TeamTech.Value.Replace("var arrTeamTech = ", "").Replace("]];", "]]");
            var teamTechlist = TeamTechjson.JsonToEntity<string[][]>();
            list.Add(teamTechlist);

            return list;
        }

        /// <summary>
        /// 球队队员信息+补充
        /// </summary>
        /// <param name="url"></param>
        /// <returns></returns>
        public teamorplayer GetteamHtml_add(string data)
        {
            teamorplayer detail = new teamorplayer();
            var html = CommonHelper.GetHtmlString_jb(TeamDetailurl.FormatMe(data), "", 1000 * 100);
            if (html.Contains("操作太频繁了，请先歇一歇"))
                Trace.WriteLine("球队队员信息：" + html);
            if (html.IsEmpty())
                return detail;
            Regex r = new Regex(@"var teamSummary =(\w|\W)*?];");
            var teamjson = r.Match(html); //设定要查找的字符串
            string teamlistjson = "";
            if (teamjson != null)
                teamlistjson = "[" + teamjson.Value.Replace("var teamSummary =[", "").Replace("];", "").Replace("[", "\"").Replace("]", "\"") + "]";
            var obj = teamlistjson.JsonToEntity<string[]>();
            if (obj != null)
            {
                B_Team team = new B_Team();
                team.City = obj[11];
                team.Coach = ("[" + obj[19] + "]").JsonToEntity<string[]>()[2];
                team.CreateDateTime = DateTime.Now;
                team.Describe = obj[16];
                team.EventId = eventId;
                team.Id = CommonHelper.GetGuid().ToString();
                team.LogoImage = "http://nba.nowscore.com" + obj[9];
                team.Name = obj[1];
                team.Remark = TeamDetailurl.FormatMe(obj[0]);
                team.Venues = obj[12];
                team.Year = obj[14];
                detail.team = team;
            }
            //球员id 集合
            r = new Regex(@"var teamPlayers = (\w|\W)*?];");
            var playerjson = r.Match(html); //设定要查找的字符串
            string playerlistjson = "";
            if (playerjson != null)
                playerlistjson = playerjson.Value.Replace("var teamPlayers = [", ",").Replace("];", "");
            //球员id 集合
            r = new Regex(@",\[(\w|\W)*?]]");
            var playerlist = r.Matches(playerlistjson);
            num += playerlist.Count;
            foreach (Match item in playerlist)
            {
                var jsonstring = ("[" + item.Value.TrimStart(',', '[').Replace("]]", "]").Replace("[", "\"").Replace("]", "\"") + "]").JsonToEntity<string[]>();
                //球员
                //Thread.Sleep(2000);
                html = CommonHelper.GetHtmlString_jb(playerDetailurl.FormatMe(jsonstring[0]), "", 1000 * 100);
                if (html.Contains("操作太频繁了，请先歇一歇"))
                    Trace.WriteLine("球队数据：" + html);
                if (html.IsEmpty())
                    return detail;
                HtmlDocument doc = new HtmlDocument();
                doc.LoadHtml(html);
                HtmlNodeCollection playerHtml = doc.DocumentNode.SelectNodes("//*[@id='Table1']//tr");
                if (playerHtml == null)
                    return detail;
                int i = 0;
                B_Players player = new B_Players();
                player.Id = CommonHelper.GetGuid().ToString();
                player.Birthday = "";
                player.EnglishName = "";
                HtmlNodeCollection Honor = doc.DocumentNode.SelectNodes("//*[@id='honorTable']/table//tr");
                if (Honor != null)
                {
                    if (Honor.Count > 1)
                    {
                        player.Honor = "";
                    }
                }
                player.Nationality = "";
                player.NBAVeteran = "";
                player.Number = "";
                player.Position = "";
                player.Remark = "1";
                player.TeamId = detail.team.Name;
                player.Weight = "";
                player.CreateDateTime = DateTime.Now;
                HtmlNodeCollection Describe = doc.DocumentNode.SelectNodes("//*[@id='introduce']");
                if (Describe != null)
                    player.Describe = Describe[0].InnerHtml.Trim();
                foreach (var item1 in playerHtml)
                {
                    HtmlDocument doc_2 = new HtmlDocument();
                    doc_2.LoadHtml(item1.InnerHtml);
                    HtmlNodeCollection playerdetailtdHtml = doc_2.DocumentNode.SelectNodes("//td");
                    if (playerdetailtdHtml.Count == 5 && i == 0)
                    {
                        string src = playerdetailtdHtml[0].SelectNodes("//img")[0].Attributes["src"].Value.Trim();
                        if (!src.IsEmpty())
                            player.LogoImage = src;
                        player.ChineseName = playerdetailtdHtml[2].InnerText.Trim();
                        player.Stature = playerdetailtdHtml[4].InnerText.Trim();
                    }
                    if (i == 1)
                    {
                        // player.ChineseName = playerdetailtdHtml[1].InnerText.Trim();
                        player.Weight = playerdetailtdHtml[3].InnerText.Trim();
                    }
                    if (i == 2)
                    {
                        player.EnglishName = playerdetailtdHtml[1].InnerText.Trim();
                        player.NBAVeteran = playerdetailtdHtml[3].InnerText.Trim();
                    }
                    if (i == 3)
                    {
                        player.Birthday = playerdetailtdHtml[1].InnerText.Trim();
                        //player.Stature = playerdetailtdHtml[3].InnerText.Trim();
                    }
                    if (i == 4)
                    {
                        player.Position = playerdetailtdHtml[1].InnerText.Trim();
                        //player.Stature = playerdetailtdHtml[3].InnerText.Trim();
                    }
                    if (i == 5)
                    {
                        player.Nationality = playerdetailtdHtml[1].InnerText.Trim();


                    }
                    i++;
                }
                detail.playerlist.Add(player);
            }

            return detail;
        }
        public class teamorplayer
        {
            public teamorplayer() {
                playerlist = new List<B_Players>();
            }
            public B_Team team { get; set; }
            public List<B_Players> playerlist { get; set; }
        }

        public class liststring
        {
            public List<string> lists {get;set;}
        }
    }

}
