﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using FCS.Common;
using FCS.Interface;
using FCS.Models;
using FCS.Models.DTO;
using HtmlAgilityPack;
using Quartz;
using Newtonsoft.Json;
using System.Text.RegularExpressions;
using System.Configuration;

namespace FCS.Crawler.ZCLotteryAgainst
{
    /// <summary>
    /// 对阵
    /// </summary>
    public class AgainstJob : CommonJob
    {
        private static List<AgainstTypeDTO> againstTypeList;//页面的参数
        private List<F_Team> teamList;//比赛信息
        private List<F_Events> eventsList;//赛事信息
        private int courteenCode = 14;//14
        private int sixHalfCode = 6;
        private int fourCode = 4;
        private List<string> vreifiList;//符号验证
        private List<AgainstEntity> result = new List<AgainstEntity>();
        public AgainstJob()
        {
            teamList = services.Query<F_Team>().ToList();
            eventsList = services.Query<F_Events>().ToList();
            vreifiList = new List<string>
            {
                "0",":","-"
            };

            againstTypeList = new List<AgainstTypeDTO> {
                new AgainstTypeDTO{
                     Code=courteenCode,
                     CaiZhong="13",
                     Url="http://cp.zgzcw.com/lottery/zcplayvs.action",
                     LotteryId="300",
                     SessionUrl1="http://cp.zgzcw.com/lottery/getissue.action?issueLen=10&lotteryId=300",//"/lottery/getwqissuereturnall.action?lotteryId=300&issueLen=20&d=1538101462272"
                     SessionUrl2="http://cp.zgzcw.com/lottery/getwqissuereturnall.action?lotteryId=300&issueLen=20&d="//"/lottery/getissue.action?lotteryId=300&issueLen=20&d=1538101378587"
                },
                  new AgainstTypeDTO{
                     Code=sixHalfCode,
                     CaiZhong="15",
                     Url="http://cp.zgzcw.com/lottery/zcplayvs.action",
                     LotteryId="302",
                     SessionUrl1="http://cp.zgzcw.com/lottery/getissue.action?issueLen=10&lotteryId=302",
                      SessionUrl2="http://cp.zgzcw.com/lottery/getwqissuereturnall.action?lotteryId=302&issueLen=20&d="
                },
                    new AgainstTypeDTO{
                     Code=fourCode,
                     CaiZhong="16",
                     Url="http://cp.zgzcw.com/lottery/zcplayvs.action",
                     LotteryId="303",
                     SessionUrl1="http://cp.zgzcw.com/lottery/getissue.action?issueLen=10&lotteryId=303",
                     SessionUrl2="http://cp.zgzcw.com/lottery/getwqissuereturnall.action?lotteryId=303&issueLen=20&d="
                },
            };
        }



        public void Click()
        {
          //  CommonHelper.LogBD(typeof(AgainstJob), () =>
            //{
                Click_500();
                return;
                againstTypeList.ForEach(d =>
                {
                    var sessionList = new List<string>();
                    if (d.Code == courteenCode)
                        sessionList = GetSession<F_Fourteen>(d, true).ToList();
                    else if (d.Code == sixHalfCode)
                        sessionList = GetSession<F_SixHalf>(d, true).ToList();
                    else
                        sessionList = GetSession<F_Four>(d, true).ToList();
                    threadCount = sessionList.Count;
                    finishcount = 0;
                    sessionList.ForEach(p =>
                    {
                        Analysis(d, p);

                    });
                    Task.WaitAll(taskList.ToArray());
                    var deleteWhere = "";
                    sessionList.ForEach(p =>
                    {
                        deleteWhere += p + ",";

                    });
                    deleteWhere = deleteWhere.ToString().Substring(0, deleteWhere.ToString().Length - 1);
                    if (d.Code == courteenCode)
                    {
                        services.Delete<F_Fourteen>(" AND Session in ({0})".FormatMe(deleteWhere));
                        services.SqlBulkCopyAdd(Mapper<List<F_Fourteen>>(result));
                    }
                    else if (d.Code == sixHalfCode)
                    {
                        services.Delete<F_SixHalf>(" AND Session in ({0})".FormatMe(deleteWhere));
                        services.SqlBulkCopyAdd(Mapper<List<F_SixHalf>>(result));
                    }
                    else
                    {
                        services.Delete<F_Four>(" AND Session in ({0})".FormatMe(deleteWhere));
                        services.SqlBulkCopyAdd(Mapper<List<F_Four>>(result));
                    }
                });
          //  });
        }

        public void GetALL()
        {
            againstTypeList.ForEach(d =>
            {
                var sessionList = GetSession<F_Fourteen>(d).ToList();
                var result = new List<AgainstEntity>();
                sessionList.ForEach(p =>
                {
                    Analysis(d, p);

                });
                while (true)
                {
                    if (CommonHelper.ThreadsFinsh())
                        break;
                }
                if (d.Code == courteenCode)
                    services.SqlBulkCopyAdd(Mapper<List<F_Fourteen>>(result));
                else if (d.Code == sixHalfCode)
                    services.SqlBulkCopyAdd(Mapper<List<F_SixHalf>>(result));
                else
                    services.SqlBulkCopyAdd(Mapper<List<F_Four>>(result));
            });
        }

        private async Task Analysis(AgainstTypeDTO d, string p)
        {
            taskList.Add(Task.Run(() =>
            {
                try
                {
                    //http://cp.zgzcw.com/lottery/zcplayvs.action?lotteryId=13&issue=18094&v=1533868879113
                    var url = d.Url + "?lotteryId=" + d.CaiZhong + "&issue=" + p + "&v=" + CommonHelper.ConvertDateTimeToInt(DateTime.Now);
                    var doc = CommonHelper.GetHtmlHtmlDocument(new HtmlParameterDTO { Url = url, Timeout = 10 * 1000, NotIpNumber = 150 });
                    while (doc.DocumentNode.InnerText.ToLower().Contains("html"))//如果包含Html，不符合
                        doc = CommonHelper.GetHtmlHtmlDocument(new HtmlParameterDTO { Url = url, Timeout = 10 * 1000, NotIpNumber = 150 });
                    if (doc.DocumentNode.InnerHtml == ConfigurationManager.AppSettings["Termination"])
                        return;
                    var data = JsonConvert.DeserializeObject<AgainstGamesData>(doc.DocumentNode.InnerText);

                    data.matchInfo.ToList().ForEach(q =>
                    {
                        var index = data.matchInfo.ToList().IndexOf(q);
                        result.Add(new AgainstEntity
                        {
                            Id = CommonHelper.GetGuid().ToString(),
                            Session = int.Parse(q.issue),
                            StartDateTime = DateTime.Parse(q.gameStartDate),
                            HomeTeamId = (from a in teamList
                                          where a.Name == Regex.Replace(q.hostName, @"\s", "")
                                          select a.Id).Take(1).ToJoin(),
                            VisitingTeamId = (from a in teamList
                                              where a.Name == Regex.Replace(q.guestName, @"\s", "")
                                              select a.Id).Take(1).ToJoin(),
                            HomeTeamName = q.hostName,
                            VisitingTeamName = q.guestName,
                            HalfResult = (vreifiList.Contains(q.zuizhongbifen.Trim()) ?
                            string.Empty : d.Code == sixHalfCode ? q.zuizhongbifen.Split(';')[index].Split(',')[0] : string.Empty),
                            Result = (vreifiList.Contains(q.zuizhongbifen.Trim()) ?
                            string.Empty : d.Code == sixHalfCode ? q.zuizhongbifen.Split(';')[index].Split(',')[1] : q.zuizhongbifen.Split(';')[index]),
                            HalfColourFruit = (d.Code == sixHalfCode || d.Code == fourCode
                            ? q.code == "0" ? string.Empty : q.code.Split(',')[index * 2]
                            : string.Empty).Replace("-", ""),
                            ColourFruit = (d.Code == sixHalfCode || d.Code == fourCode
                            ? q.code == "0" ? string.Empty : q.code.Split(',')[index * 2 + 1]
                            : q.code == "0" ? string.Empty : q.code.Split(',')[index]
                            ).Replace("-", ""),
                            Compensate_SOdd = q.europeSp.Trim().IsEmpty() ? 0 : float.Parse(q.europeSp.Split(' ')[0]),
                            Compensate_POdd = q.europeSp.Trim().IsEmpty() ? 0 : float.Parse(q.europeSp.Split(' ')[1]),
                            Compensate_FOdd = q.europeSp.Trim().IsEmpty() ? 0 : float.Parse(q.europeSp.Split(' ')[2]),
                            AsianDish_SOdd = q.yapan.Trim().IsEmpty() ? 0 : float.Parse(q.europeSp.Split(' ')[0]),
                            AsianDish_Disc = q.yapan.Trim().IsEmpty() ? "" : q.yapan.Split(' ')[1],
                            AsianDish_FOdd = q.yapan.Trim().IsEmpty() ? 0 : float.Parse(q.yapan.Split(' ')[2]),
                            EventId = eventsList.Where(s => s.Name.Contains(Regex.Replace(q.leageName, @"\s", ""))).ToList()[0].Id,
                            CreateDateTime = DateTime.Now,
                            Sort = index + 1

                        });
                    });
                }
                catch (Exception ex)
                {

                }
                finally
                {
                    lock (locker)
                    {
                        finishcount++;
                        Monitor.Pulse(locker); //完成，通知等待队列,告知已完，执行下一个。
                    }
                }
            }));


        }


        /// <summary>
        /// 得到期数
        /// </summary>
        /// <param name="url"></param>
        /// <returns></returns>
        private IEnumerable<string> GetSession<T>(AgainstTypeDTO model, bool isUpdate = false)
        {
            var sessionList = new List<string>();
            if (isUpdate)
            {
                var nosessionList = services.Query<T, AgainstEntity>(" AND Result IS NULL OR Result =''", "", "a.Session").ToList();
                if (nosessionList.Count <= 0)
                {
                    nosessionList = services.Query<T, AgainstEntity>("", "", "max(a.Session) as Session").ToList();
                    if (nosessionList.Count > 0)
                        sessionList = (from a in nosessionList
                                       select a.Session.ToString()).Distinct().ToList();
                }
                else
                {
                    sessionList = (from a in nosessionList
                                   select a.Session.ToString()).Distinct().ToList();
                }
            }
            //期数1
            var doc = CommonHelper.GetHtmlHtmlDocument(new HtmlParameterDTO { Url = model.SessionUrl1, Timeout = 10 * 1000 });
            while (doc.DocumentNode.InnerText.ToLower().Contains("html"))
                doc = CommonHelper.GetHtmlHtmlDocument(new HtmlParameterDTO { Url = model.SessionUrl1, Timeout = 10 * 1000 });
            var list = new List<AgainstSession>();
            if (doc.DocumentNode.InnerHtml != ConfigurationManager.AppSettings["Termination"])
                list = JsonConvert.DeserializeObject<List<AgainstSession>>(doc.DocumentNode.InnerText);

            //期数2
            var url = model.SessionUrl2 + CommonHelper.ConvertDateTimeToInt(DateTime.Now);
            doc = CommonHelper.GetHtmlHtmlDocument(new HtmlParameterDTO { Url = url, Timeout = 10 * 1000 });
            while (doc.DocumentNode.InnerText.ToLower().Contains("html") || doc.DocumentNode.InnerText.ToLower().Contains("url") || doc.DocumentNode.InnerText.IsEmpty())
                doc = CommonHelper.GetHtmlHtmlDocument(new HtmlParameterDTO { Url = url, Timeout = 10 * 1000 });
            if (doc.DocumentNode.InnerHtml != ConfigurationManager.AppSettings["Termination"])
            {
                var list1 = JsonConvert.DeserializeObject<List<AgainstSession>>(doc.DocumentNode.InnerText);

                //判断依据来自：zc.min.js(对于页面的js分析得出)
                list1 = (from a in list1
                         where a.status != "9" && !(from b in list select b.issue).Contains(a.issue)
                         select a).ToList();
                list = list.Concat(list1).Distinct().ToList();
            }

            if (sessionList != null)
            {
                if (sessionList.Count > 0)
                {
                    var list_y = from a in list
                                 join b in sessionList on a.issue equals b
                                 select b;
                    if (list_y.Count() <= 0)
                        list_y = sessionList;
                    var session = list_y.OrderBy(p => p).ToList()[0];
                    return (from a in list
                            where int.Parse(a.issue) >= int.Parse(session.IsEmpty() ? "0" : session)
                            select a.issue
                            ).Distinct();
                }
            }
            return (from a in list
                    select a.issue
                        ).Distinct();

        }

        /// <summary>
        /// 500万数据更新
        /// </summary>
        private void Click_500()
        {
            var list = new List<string> {
               "http://www.500.com/static/info/sfc/daigou/xml/index.xml",//14
               "http://www.500.com/static/info/jq4/daigou/xml/index.xml",//4
               "http://www.500.com/static/info/zc6/daigou/xml/index.xml",//6
            };
            var sessionList = new List<string>();

           var nowSessionsdoc = CommonHelper.GetHtmlHtmlDocument(new HtmlParameterDTO { Url = "https://www.500.com/", Timeout = 10 * 1000, TranslationEncoding = Encoding.Default, Title = "500彩票网" });
            list.ForEach(p =>
            {
                sessionList = new List<string>();
                result = new List<AgainstEntity>();
                var nosessionList = new List<AgainstEntity>();
                if (p.Contains("sfc"))
                    nosessionList = services.Query<F_Fourteen, AgainstEntity>($"AND Result IS NOT  NULL AND Result <>'' AND ColourFruit IS NOT NULL AND  ColourFruit <>''", "", "max(Session) as Session").ToList();
                else if (p.Contains("zc6"))
                    nosessionList = services.Query<F_SixHalf, AgainstEntity>($" AND Result IS NOT  NULL AND Result <>'' AND ColourFruit IS NOT NULL AND  ColourFruit <>''", "", "max(Session) as Session").ToList();
                else
                    nosessionList = services.Query<F_Four, AgainstEntity>($"AND Result IS NOT  NULL AND Result <>'' AND ColourFruit IS NOT NULL AND  ColourFruit <>''", "", "max(Session) as Session").ToList();
                var doc = CommonHelper.GetHtmlHtmlDocument(new HtmlParameterDTO { Url = p, Timeout = 10 * 1000 });
                var number = 1;
                while (doc.DocumentNode.InnerHtml.ToLower().Contains("html") || !doc.DocumentNode.InnerHtml.ToLower().Contains("xml"))
                {
                    if (number > 3)
                        break;
                    doc = CommonHelper.GetHtmlHtmlDocument(new HtmlParameterDTO { Url = p, Timeout = 10 * 1000 });
                    number++;
                }
                if (doc.DocumentNode.InnerHtml == ConfigurationManager.AppSettings["Termination"])//不存在退出
                    return;
                var sessionsList = doc.DocumentNode.SelectNodes(".//row");
                var nowSessions = nowSessionsdoc.DocumentNode.SelectSingleNode("//div[@id='scroll_con']").SelectNodes("//dl[@class='kj_sort']")[list.IndexOf(p)].SelectNodes(".//span[@class='eng']")[0].InnerText;
                if (nowSessions.TryToInt32() != nosessionList[0].Session)
                {
                    sessionList.Add(nowSessions);
                    taskList.Add(Task.Run(() => AddData_500(p.Replace("index", nowSessions), nowSessions)));
                }
                foreach (var item in sessionsList)
                {
                    var sessions = item.Attributes["expect"].Value;
                    if (sessions == nowSessions)
                        continue;
                    if (nosessionList.Count() <= 0 || sessions.TryToInt32() >= nosessionList[0].Session)
                    {
                        sessionList.Add(sessions);
                        taskList.Add(Task.Run(() => AddData_500(p.Replace("index", sessions), sessions)));
                    }
                }
                Thread.Sleep(1000 * 60);
                Task.WaitAll(taskList.ToArray());

                var deleteWhere = "";
                sessionList.ForEach(q =>
                {
                    deleteWhere += q + ",";

                });
                deleteWhere = deleteWhere.ToString().Substring(0, deleteWhere.ToString().Length - 1);
                if (p.Contains("sfc"))
                {
                    services.Delete<F_Fourteen>(" AND Session in ({0})".FormatMe(deleteWhere));
                    services.SqlBulkCopyAdd(Mapper<List<F_Fourteen>>(result));
                }
                else if (p.Contains("zc6"))
                {
                    services.Delete<F_SixHalf>(" AND Session in ({0})".FormatMe(deleteWhere));
                    services.SqlBulkCopyAdd(Mapper<List<F_SixHalf>>(result));
                }
                else
                {
                    services.Delete<F_Four>(" AND Session in ({0})".FormatMe(deleteWhere));
                    services.SqlBulkCopyAdd(Mapper<List<F_Four>>(result));
                }
            });
        }


        private void AddData_500(string url, string session)
        {
            //http://www.500.com/static/public/sfc/daigou/xml/18164.xml 14
            //http://www.500.com/static/info/zc6/daigou/xml/index.xml  6
            //http://www.500.com/static/public/jq4/daigou/xml/18174.xml 4
            if (url.Contains("sfc"))
                url = $"http://www.500.com/static/public/sfc/daigou/xml/{session}.xml";
            else if (url.Contains("zc6"))
                url = $"http://www.500.com/static/public/zc6/daigou/xml/{session}.xml";
            else
                url = $"http://www.500.com/static/public/jq4/daigou/xml/{session}.xml";
            var doc = CommonHelper.GetHtmlHtmlDocument(new HtmlParameterDTO { Url = url, Timeout = 10 * 1000});
            var number = 1;
            while (doc.DocumentNode.InnerHtml.ToLower().Contains("html") || !doc.DocumentNode.InnerHtml.ToLower().Contains("xml"))
            {
                if (number > 3)
                    break;
                doc = CommonHelper.GetHtmlHtmlDocument(new HtmlParameterDTO { Url = url, Timeout = 10 * 1000 });
                number++;
            }
            if (doc.DocumentNode.InnerHtml == ConfigurationManager.AppSettings["Termination"]|| doc.DocumentNode.SelectNodes(".//head") == null || doc.DocumentNode.InnerHtml.ToLower().Contains("html"))//不存在退出
                return;

            var data = doc.DocumentNode.SelectNodes(".//row");
            var year = doc.DocumentNode.SelectNodes(".//head")[0].Attributes["fsendtime"].Value.TryToDateTime().ToString("yyyy");
            foreach (var item in data)
            {
                result.Add(new AgainstEntity
                {
                    Id = CommonHelper.GetGuid().ToString(),
                    Session = int.Parse(session),
                    StartDateTime = (year + "-" + item.Attributes["resultscore"].Value).TryToDateTime(),
                    HomeTeamId = (from a in teamList
                                  where a.Name == item.Attributes["hometeam"].Value
                                  select a.Id).Take(1).ToJoin(),
                    VisitingTeamId = (from a in teamList
                                      where a.Name == item.Attributes["guestteam"].Value
                                      select a.Id).Take(1).ToJoin(),
                    HomeTeamName = item.Attributes["hometeam"].Value.Replace("&amp;nbsp;", ""),
                    VisitingTeamName = item.Attributes["guestteam"].Value.Replace("&amp;nbsp;", ""),

                    HalfResult = item.Attributes["hhomescore"].IsEmpty() ? string.Empty :
                                     item.Attributes["hhomescore"].Value + "-" + item.Attributes["hguestscore"].Value,
                    Result = !url.Contains("jq4") ? item.Attributes["homescore"].Value == "-1" ? string.Empty : item.Attributes["homescore"].Value + "-" + item.Attributes["guestscore"].Value
                             : item.Attributes["homeresult"].Value.IsEmpty() ? string.Empty : item.Attributes["homeresult"].Value + "-" + item.Attributes["guestresult"].Value,

                    HalfColourFruit = !url.Contains("jq4") ? item.Attributes["halfresult"].IsEmpty() ? string.Empty : item.Attributes["halfresult"].Value
                                       : item.Attributes["homeresult"].Value,
                    ColourFruit = !url.Contains("jq4") ? item.Attributes["result"].Value : item.Attributes["guestresult"].Value,

                    CreateDateTime = DateTime.Now,
                    Sort = data.IndexOf(item) + 1
                });
            }
        }

    }

}
