﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using FCS.Common;
using FCS.Interface;
using FCS.Models;
using HtmlAgilityPack;
using Quartz;

namespace FCS.Crawler.ZCLotteryGames
{
   public class GamesJob : CommonJob, IJob
    {
        
        public GamesJob()
        {
            logName = "GamesJob";
            log = new LogHelper();
            services = IOC.Resolve<IDTOpenCode>();
            g = new F_Grouping();
        }
        public void Execute(IJobExecutionContext context)
        {
            //Config = CommonHelper.GetConfigFromDataMap(context.JobDetail.JobDataMap);
            Click();
        }
        public List<string> gamelist = new List<string>();
        public List<string> urllist = new List<string>();
        public  List<string> urllist2 = new List<string>();
        public  List<F_Grouping> Group = new List<F_Grouping>();
        public  List<F_Grouping> Group1 = new List<F_Grouping>();
        public  List<F_Grouping> GroupParent = new List<F_Grouping>();
        public  List<F_Team> teamlist = new List<F_Team>();
        public  List<F_Grouping> GroupList = null;
        public  List<F_Grouping> GroupList1 = null;
        public  List<F_Games> Gamelist = null;
        public static List<F_Games> gamesList = new List<F_Games>();
        public static List<F_Games> gamesList_new = new List<F_Games>();
        public  List<F_Games> gamesList_new1 = new List<F_Games>();
        public  List<F_Games> gamesList_new2 = new List<F_Games>();
        public  List<int> listint = new List<int>();//需要删除的比赛PK
        //比赛状态
        private string g1 = "d0da55f0c86ae811ab3100ac6a4a134f", g2 = "907dbd11c96ae811ab3100ac6a4a134f", g3 = "a058ec2ec96ae811ab3100ac6a4a134f";
        F_Grouping g;

        public List<F_Games> Click()
        {
            return CommonHelper.LogBD<List<F_Games>>(typeof(GamesJob), () =>
            {
                try
                {
                    string Season = DateTime.Now.ToString("yyyy");
                    Group = services.Query<F_Grouping>().ToList();
                    Group1 = services.Query<F_Grouping>(" and Id in( select aa.Id from F_Grouping as aa left join F_Games as b on aa.Id=b.GroupingId where b.[Status]!='a058ec2ec96ae811ab3100ac6a4a134f' and aa.Season like '%{0}%' and b.Season like '%{0}%' group by aa.Id)".FormatMe(Season)).ToList();
                    Group1.AddRange(services.Query<F_Grouping>(" and Id in ( select aa.Id from F_Grouping as aa left join F_Games as b on aa.Id=b.GroupingId where b.Id is null and aa.Season like '%{0}%' group by aa.Id)".FormatMe(Season)).ToList());
                    Gamelist = services.Query<F_Games>(" AND Season LIKE '%{0}%'".FormatMe(Season)).ToList();
                    teamlist = services.Query<F_Team>().ToList();
                    GroupList = Group1.Where(a => !a.Remark.Contains("/cup/41/") && ((a.ParentId.Length == 0 && a.Remark.Contains("/cup/")) || a.Remark.Contains("/league/"))).ToList();
                    GroupParent = services.Query<F_Grouping>("and ParentId!=''").ToList();
                    int max = GroupList.Count;
                    int num = 0;
                    //比赛
                    GroupList.ForEach(async p =>
                    {
                        await Task.Run(() =>
                        {
                            Trace.WriteLine("获取比赛 开始：" + GroupList.IndexOf(p));
                            GetClick(p.Remark, p.Name.Trim(), p.Id);

                        });
                        lock (g)
                        {

                            num++;
                            Monitor.Pulse(g); //完成，通知等待队列,告知已完，执行下一个。
                        }
                    });
                    lock (g)
                    {
                        while (num < max)
                        {
                            Monitor.Wait(g);//等待
                        }
                    }
                    Trace.WriteLine("获取比赛 完结");


                    //球队联谊
                    //var q = Group.Where(a => a.Remark.Contains("/cup/41/") && a.Season.Contains(Season)).ToList();
                    //List<string> ulist = new List<string>();
                    //foreach (var item in q)
                    //{
                    //    ulist.Add(item.Remark);
                    //}
                    //ulist = ulist.Distinct().ToList();
                    //foreach (var item in ulist)
                    //{
                    //    GetCupData_yy(item, q);
                    //}

                    ////检查缺漏
                    List<string> new_urllist = new List<string>();
                    new_urllist = urllist;
                    max = new_urllist.Count;
                    num = 0;
                    urllist = new List<string>();
                    new_urllist.ForEach(async p =>
                    {
                        await Task.Run(() =>
                        {
                            Trace.WriteLine("获取比赛 缺漏 开始：" + new_urllist.IndexOf(p));
                            var query = p.Split('|');
                            GetLeagueData(query[0], query[1], query[2]);

                        });
                        lock (g)
                        {
                            num++;
                            Monitor.Pulse(g); //完成，通知等待队列,告知已完，执行下一个。
                        }
                    });
                    lock (g)
                    {
                        while (num != max)
                        {
                            Monitor.Wait(g);//等待
                        }
                    }
                    try
                    {
                        gamesList = gamesList.Where(a => a != null).ToList();
                        gamesList = gamesList.Where(a => a.Id != null).OrderByDescending(a => a.CreateDateTime).ToList();
                    }
                    catch (Exception e)
                    {
                        CommonHelper.LogBD(e.Message + "\b\r\t" + gamesList.TryToJson(), "gamedata");
                        //throw;
                    }

                    gamesList = gamesList.Where((x, i) => gamesList.FindIndex(z => z.GroupingId == x.GroupingId && z.VisitingTeamId == x.VisitingTeamId && z.HomeTeamId == x.HomeTeamId && z.HomeTeamScore_All == x.HomeTeamScore_All && z.VisitingTeamScore_All == x.VisitingTeamScore_All && z.HomeTeamScore_Half == x.HomeTeamScore_Half && z.VisitingTeamScore_Half == x.VisitingTeamScore_Half && z.EventId == x.EventId && z.Season == x.Season) == i).ToList();//Lambda表达式去重

                    var group = gamesList.GroupBy(a => a.GroupingId).Select(g => g.Last()).ToList();
                    foreach (var item in group)
                    {
                        var new_group_game = gamesList.Where(a => a.GroupingId == item.GroupingId).ToList();
                        var group_game = Gamelist.Where(a => a.GroupingId == item.GroupingId).ToList();

                        foreach (var item1 in new_group_game)
                        {
                            switch (group_game.Where(a => a.GroupingId == item.GroupingId && a.HomeTeamId == item1.HomeTeamId && a.VisitingTeamId == item1.VisitingTeamId && a.StartDateTime == item1.StartDateTime && a.Status == item1.Status).ToList().Count)
                            {
                                case 0:
                                    gamesList_new.Add(item1);
                                    break;
                                case 1:
                                    var gamedetail = group_game.Where(a => a.GroupingId == item.GroupingId && a.HomeTeamId == item1.HomeTeamId && a.VisitingTeamId == item1.VisitingTeamId && a.StartDateTime == item1.StartDateTime && a.Status == item1.Status).FirstOrDefault();
                                    var new_game = item1;
                                    new_game.Id = gamedetail.Id;
                                    gamesList_new.Add(new_game);
                                    break;
                                default:
                                    var gamedetail1 = group_game.Where(a => a.GroupingId == item.GroupingId && a.HomeTeamId == item1.HomeTeamId && a.VisitingTeamId == item1.VisitingTeamId && a.StartDateTime == item1.StartDateTime && a.Status == item1.Status).ToList();
                                    var new_game1 = item1;
                                    new_game1.Id = gamedetail1.OrderByDescending(a => a.CreateDateTime).FirstOrDefault().Id;
                                    gamesList_new.Add(new_game1);
                                    break;
                            }
                        }

                        foreach (var item1 in group_game)
                        {
                            listint.Add(item1.PK);
                        }
                    }
                    Thread.Sleep(5000);
                    var gamesList_new1 = gamesList_new.Where(a => a.StartDateTime < DateTime.Now.AddDays(5)).ToList();
                    var salist1 = gamesList_new.Where((x, i) => gamesList_new.FindIndex(z => z.GroupingId == x.GroupingId && z.VisitingTeamId == x.VisitingTeamId && z.HomeTeamId == x.HomeTeamId && z.HomeTeamScore_All == x.HomeTeamScore_All && z.VisitingTeamScore_All == x.VisitingTeamScore_All && z.HomeTeamScore_Half == x.HomeTeamScore_Half && z.VisitingTeamScore_Half == x.VisitingTeamScore_Half && z.EventId == x.EventId && z.Season == x.Season && z.Id == x.Id) == i).ToList();//Lambda表达式去重
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                //gamesList2 = gamesList_new2.Where(a => a.StartDateTime < Convert.ToDateTime(DateTime.Now.ToString("yyyy-MM-dd"))&& a.StartDateTime > Convert.ToDateTime(DateTime.Now.AddDays(-1).ToString("yyyy-MM-dd"))).ToList();
                    Trace.WriteLine("插入数据 开始：" + salist1.Count);
                    int pages = salist1.Count % 1000 == 0 ? salist1.Count / 1000 : salist1.Count / 1000 + 1;
                    for (int i = 0; i < pages; i++)
                    {
                        var gamel = salist1.Skip(1000 * i).Take(1000).ToList();
                        CommonHelper.LogBD("插入比赛数据 进行中" + gamel.Count, "Update_RealTimeJob");
                        services.SqlBulkCopyAdd<F_Games>(gamel);
                    }

                    CommonHelper.LogBD("插入比赛数据 结束" + salist1.Count, "Update_RealTimeJob");
                    Trace.WriteLine("插入数据 结束：" + salist1.Count);

                    Trace.WriteLine("删除数据 开始：" + listint.Count);
                    if (listint.Count > 0)
                    {
                        int pg = listint.Count % 10000 == 0 ? listint.Count / 10000 : listint.Count / 10000 + 1;
                        for (int i = 0; i < pg; i++)
                        {
                            var listint1 = listint.Skip(i * 10000).Take(10000).ToList();
                            services.Delete<F_Games>(" and PK in (" + string.Join(",", listint1) + ")");
                        }

                    }

                    Trace.WriteLine("删除数据 结束：" + listint.Count);



                    List<int> rlist = new List<int>();
                    var querygame = services.Query<F_Games>(" and Id in (select Id from ( select Id,COUNT(Id) as num from F_Games group by Id) as s where s.num>1 ) ").ToList();
                    var q1 = querygame.Where((x, i) => querygame.FindIndex(z => z.Id == x.Id) == i).ToList();//Lambda表达式去重
                    foreach (var item in querygame)
                    {
                        if (q1.Where(a => a.PK == item.PK).ToList().Count > 0)
                        {
                            continue;
                        }
                        else
                        {
                            rlist.Add(item.PK);
                        }
                    }
                    if (rlist.Count > 0)
                    {
                        int pg = rlist.Count % 10000 == 0 ? rlist.Count / 10000 : rlist.Count / 10000 + 1;
                        for (int i = 0; i < pg; i++)
                        {
                            var listint1 = rlist.Skip(i * 10000).Take(10000).ToList();
                            services.Delete<F_Games>(" and PK in (" + string.Join(",", listint1) + ")");
                        }
                    }
                    gamesList = new List<F_Games>();
                    gamesList_new = new List<F_Games>();
                    return gamesList_new1;
                }
                catch (Exception e)
                {
                    CommonHelper.LogBD("比赛错误：" + e.Message, "CWLog");
                    CommonHelper.LogBD(e.Message, logName);
                    CommonHelper.LogBD(e.Source, logName);
                    CommonHelper.LogBD(e.StackTrace, logName);
                    gamesList = new List<F_Games>();
                    gamesList_new = new List<F_Games>();
                    return new List<F_Games>();
                }
            });
        
           
        }

        /// <summary>
        /// 某某杯
        /// </summary>
        /// <param name="url"></param>
        public void GetCupData(string url, string currentRound, string Id)
        {

            try
            {
                List<F_Games> game_newList = new List<F_Games>();
                Trace.WriteLine("某某杯 开始：" + url);
                string yurl = url;
                url = url.Replace(":80", "");
                var htmlResource = CommonHelper.GetHtmlString(url, "足彩");
                HtmlDocument doc = new HtmlDocument();
                if (htmlResource == null)
                    return;
                doc.LoadHtml(htmlResource);
                //比赛分组集合
                HtmlNodeCollection GamegroupHtml = doc.DocumentNode.SelectNodes("//*[@id='tabs9']/li");
                foreach (var item in GamegroupHtml.Where(a => a.InnerText.Trim() == currentRound))
                {//获取父下所有子分组+比赛
                    string shuju1 = "";
                    if (GroupParent.Where(a => a.ParentId == Id).ToList().Count > 0)
                    {//有子集比赛集合
                        HtmlNodeCollection groupHtml = doc.DocumentNode.SelectNodes("//*[@id='tabs9_" + item.Id + "']");
                        if (groupHtml == null)
                            return;
                        HtmlDocument doc_1 = new HtmlDocument();
                        doc_1.LoadHtml(groupHtml[0].OuterHtml);
                        HtmlNodeCollection groupHtmlnew = doc_1.DocumentNode.SelectNodes("//li");
                        foreach (var item1 in groupHtmlnew)
                        {
                            var zj = GroupParent.Where(a => a.ParentId == Id && a.Name == item1.InnerText.Trim()).ToList();
                            if(zj.Count==0)
                                continue;
                            //获取所有子集
                            HtmlNodeCollection itemlist_1 = doc_1.DocumentNode.SelectNodes("//*[@id='div_" + item1.Id + "']/table");
                            if (itemlist_1 == null)
                                return;
                            HtmlDocument doc2 = new HtmlDocument();
                            doc2.LoadHtml(itemlist_1[0].OuterHtml);
                            HtmlNodeCollection itemlist = doc2.DocumentNode.SelectNodes("//tr");
                            foreach (HtmlNode node in itemlist)
                            {
                                var list = node.SelectNodes("td");
                                if (list == null)
                                    continue;
                                string shuju = shuju1;
                                foreach (var item3 in list)
                                {
                                    shuju += item3.InnerText.Trim() + "|";
                                }
                                //gamelist.Add(shuju);
                                var listurl = url.Split('/');
                                string season = listurl[6];
                                HtmlDocument doc3 = new HtmlDocument();
                                doc3.LoadHtml(list.Last().InnerHtml);
                                HtmlNodeCollection itemlist2 = doc3.DocumentNode.SelectNodes("//a");
                                var q_new=Insert_new(shuju, zj[0].Id, season, itemlist2[0].Attributes["href"].Value);
                                if(q_new!=null)
                                    game_newList.Add(q_new);
                            }
                        }
                       

                    }
                    else {
                        //比赛集合
                        HtmlNodeCollection GameHtml = doc.DocumentNode.SelectNodes("//*[@id='tabs9_" + item.Id + "']");
                        foreach (var item1 in GameHtml)
                        {
                            HtmlDocument doc1 = new HtmlDocument();
                            doc1.LoadHtml(item1.OuterHtml);
                            HtmlNodeCollection itemlist = doc1.DocumentNode.SelectNodes("//table").Last().SelectNodes("//tr");
                            foreach (HtmlNode node in itemlist)
                            {
                                var list = node.SelectNodes("td");
                                if (list == null)
                                    continue;
                                string shuju = shuju1;
                                foreach (var item3 in list)
                                {
                                    shuju += item3.InnerText.Trim() + "|";
                                }
                                //gamelist.Add(shuju);
                                var listurl = url.Split('/');
                                string season = listurl[6];
                                HtmlDocument doc2 = new HtmlDocument();
                                doc2.LoadHtml(list.Last().InnerHtml);
                                HtmlNodeCollection itemlist2 = doc2.DocumentNode.SelectNodes("//a");
                                var q_new = Insert_new(shuju, Id, season, itemlist2[0].Attributes["href"].Value);
                                if (q_new != null)
                                    game_newList.Add(q_new);
                            }
                        }
                    }
                    
                    
                }
                if(game_newList.Count>0)
                    gamesList.AddRange(game_newList);
            }
            catch (Exception e)
            {

              //  Trace.WriteLine("某某杯 发生异常：" + url);
            }



        }

        public void GetClick(string url, string currentRound, string Id)
        {
            if (url.Contains("cup"))
            {
                GetCupData(url, currentRound, Id);
            }
            else
            {
                GetLeagueData(url, currentRound, Id);
            }
        }
        /// <summary>
        /// 某某杯 友谊
        /// </summary>
        /// <param name="url"></param>
        public void GetCupData_yy(string url, List<F_Grouping> glist)
        {
            string currentRound, Id;
            try
            {
                Trace.WriteLine("某某杯 开始：" + url);
                url = url.Replace(":80", "");
                var htmlResource = CommonHelper.GetHtmlString(url, "足彩");
                HtmlDocument doc = new HtmlDocument();
                if (htmlResource == null)
                    return;
                doc.LoadHtml(htmlResource);
                //比赛分组集合
                HtmlNodeCollection GamegroupHtml = doc.DocumentNode.SelectNodes("//*[@id='tabs9']/li");
                foreach (var item in GamegroupHtml)
                {
                    string shuju1 = "";
                    //比赛集合
                    HtmlNodeCollection GameHtml = doc.DocumentNode.SelectNodes("//*[@id='tabs9_" + item.Id + "']");
                    foreach (var item1 in GameHtml)
                    {
                        HtmlDocument doc1 = new HtmlDocument();
                        doc1.LoadHtml(item1.OuterHtml);
                        HtmlNodeCollection itemlist = doc1.DocumentNode.SelectNodes("//table").Last().SelectNodes("//tr");
                        foreach (HtmlNode node in itemlist)
                        {
                            var list = node.SelectNodes("td");
                            if (list == null)
                                continue;
                            string shuju = shuju1;
                            foreach (var item3 in list)
                            {
                                shuju += item3.InnerText.Trim() + "|";
                            }
                            //gamelist.Add(shuju);
                            var listurl = url.Split('/');
                            string season = listurl[6];
                            HtmlDocument doc2 = new HtmlDocument();
                            doc2.LoadHtml(list.Last().InnerHtml);
                            HtmlNodeCollection itemlist2 = doc2.DocumentNode.SelectNodes("//a");
                            var sss = glist.Where(a => a.Name.Trim() == item.InnerText.Trim() && a.Remark.Replace(":80", "") == url).FirstOrDefault();
                            Id = glist.Where(a => a.Name.Trim() == item.InnerText.Trim() && a.Remark.Replace(":80", "") == url).FirstOrDefault() == null ? "" : glist.Where(a => a.Name.Trim() == item.InnerText.Trim() && a.Remark.Replace(":80", "") == url).FirstOrDefault().Id;
                            Insert(shuju, Id, season, itemlist2[0].Attributes["href"].Value);
                        }
                    }
                }

            }
            catch (Exception e)
            {

                Trace.WriteLine("某某杯 发生异常：" + url);
            }



        }
        /// <summary>
        /// 国家赛事
        /// </summary>
        /// <param name="url"></param>
        public void GetLeagueData(string url, string currentRound, string Id)
        {
            string msg = "";
            try
            {
                Trace.WriteLine("国家赛事 开始：" + url);
                List<F_Games> game_newList = new List<F_Games>();
                url = url.Replace(":80", "");
                int Round = -1;
                try
                {
                    Round = Convert.ToInt32(currentRound);
                }
                catch (Exception e)
                {

                    Round = -1;
                }
                if (Round != -1)
                {
                    var listurl = url.Split('/');
                    string source_league_id = listurl[5];
                    string season = listurl[6];
                    var html = CommonHelper.GetPostHtmlString(url, new HttpItem
                    {
                        Url = "http://saishi.zgzcw.com/summary/liansaiAjax.action",
                        Method = "Post",
                        WebProxy = new WebProxy(CommonHelper.GetIp()),
                        FormData = new Dictionary<string, string>()
                    {
                        { "source_league_id" , source_league_id },
                        { "currentRound",currentRound},
                        { "season",season},
                        { "seasonType",""},
                    },
                        ContentType = "application/x-www-form-urlencoded",
                    });
                    //常规赛
                    msg = html.Html;
                    HtmlDocument doc = new HtmlDocument();
                    if (html.Html == null)
                        return;
                    doc.LoadHtml(html.Html);

                    //比赛集合
                    HtmlNodeCollection itemlist = doc.DocumentNode.SelectNodes("//table/tr");
                    foreach (HtmlNode node in itemlist)
                    {
                        var list = node.SelectNodes("td");
                        string shuju = "";
                        foreach (var item3 in list)
                        {
                            shuju += item3.InnerText.Trim() + "|";
                        }
                        //gamelist.Add(shuju);
                        HtmlDocument doc2 = new HtmlDocument();
                        doc2.LoadHtml(list.Last().InnerHtml);
                        HtmlNodeCollection itemlist2 = doc2.DocumentNode.SelectNodes("//a");
                        var q_new = Insert_new(shuju, Id, season, itemlist2[0].Attributes["href"].Value);
                        if (q_new != null)
                            game_newList.Add(q_new);
                    }
                }
                else
                {
                    var listurl = url.Split('/');
                    string source_league_id = listurl[5];
                    string season = listurl[6];
                    var html = CommonHelper.GetPostHtmlString(url, new HttpItem
                    {
                        Url = "http://saishi.zgzcw.com/summary/liansaifjAction.action",
                        Method = "Post",
                        WebProxy = new WebProxy(CommonHelper.GetIp()),
                        FormData = new Dictionary<string, string>()
                    {
                       { "source_league_id" , source_league_id},
                        { "hostTeamId","0"},
                        { "guestTeamId","0"},
                        { "season",season},
                        { "seasonType","1"},
                    },
                        ContentType = "application/x-www-form-urlencoded",
                    });
                    msg = html.Html;
                    HtmlDocument doc = new HtmlDocument();
                    if (html.Html == null)
                        return;
                    doc.LoadHtml(html.Html);

                    //附加比赛集合
                    HtmlNodeCollection itemlist = doc.DocumentNode.SelectNodes("//*[@id ='fjtab']/tr");
                    if (itemlist == null)
                    {
                        Trace.WriteLine("附加赛没有数据" + url);
                        return;
                    }
                    foreach (HtmlNode node1 in itemlist)
                    {
                        var list1 = node1.SelectNodes("td");
                        string shuju = "";
                        foreach (var item3 in list1)
                        {
                            shuju += item3.InnerText.Trim() + "|";
                        }
                        // gamelist.Add(shuju);
                        HtmlDocument doc2 = new HtmlDocument();
                        doc2.LoadHtml(list1.Last().InnerHtml);
                        HtmlNodeCollection itemlist2 = doc2.DocumentNode.SelectNodes("//a");
                        var q_new = Insert_new(shuju, Id, season, itemlist2[0].Attributes["href"].Value);
                        if (q_new != null)
                            game_newList.Add(q_new);
                    }


                }
                if (game_newList.Count > 0)
                    gamesList.AddRange(game_newList);
            }
            catch (Exception e)
            {
                urllist.Add(url + "|" + currentRound + "|" + Id);
               // Trace.WriteLine("某某杯 发生异常：" + url + "_:" + currentRound + ":_" + "__" + msg);
            }



        }

        /// <summary>
        /// 插入数据
        /// </summary>
        /// <param name="data"></param>
        /// <param name="Id"></param>
        /// <param name="Season"></param>
        public void Insert(string data, string Id, string Season, string url)
        {
            lock (gamesList)
            {
                var query = data.Split('|');
                F_Games game = new F_Games();
                game.Id = CommonHelper.GetGuid().ToString();
                game.CreateDateTime = DateTime.Now;
                game.EventId = Group.Where(a => a.Id == Id).FirstOrDefault().EventId;
                game.EventType = Group.Where(a => a.Id == Id).FirstOrDefault().EventType;
                game.Heat = 0;
                var team = teamlist.Where(a => a.Name == query[1]).FirstOrDefault();
                if (team == null)
                    return;
                game.HomeTeamId = team == null ? "" : team.Id;
                game.HomeTeamScore_All = query[2].Split(':')[0].TryToInt32();
                game.HomeTeamScore_Half = query[4].Split(':')[0].TryToInt32();
                game.IsOvertime = false;
                game.Remark = url;
                game.Season = Season;
                game.StartDateTime = Convert.ToDateTime(query[0]);
                game.Status = query[4] == "-:-" ? g1 : query[2] == "-:-" ? g2 : g3;
                team = teamlist.Where(a => a.Name == query[3]).FirstOrDefault();
                if (team == null)
                    return;
                game.VisitingTeamId = team.Id;
                game.VisitingTeamScore_All = query[2].Split(':')[1].TryToInt32();
                game.VisitingTeamScore_Half = query[4].Split(':')[1].TryToInt32();
                game.GroupingId = Id;
                game.IsObtain = false;
                gamesList.Add(game);
            }
            
        }
        /// <summary>
        /// 插入数据
        /// </summary>
        /// <param name="data"></param>
        /// <param name="Id"></param>
        /// <param name="Season"></param>
        public F_Games Insert_new(string data, string Id, string Season, string url)
        {
            
                var query = data.Split('|');
                F_Games game = new F_Games();
                game.Id = CommonHelper.GetGuid().ToString();
                game.CreateDateTime = DateTime.Now;
                game.EventId = Group.Where(a => a.Id == Id).FirstOrDefault().EventId;
                game.EventType = Group.Where(a => a.Id == Id).FirstOrDefault().EventType;
                game.Heat = 0;
                var team = teamlist.Where(a => a.Name == query[1]).FirstOrDefault();
                if (team == null)
                    return new F_Games();
                game.HomeTeamId = team == null ? "" : team.Id;
                game.HomeTeamScore_All = query[2].Split(':')[0].TryToInt32();
                game.HomeTeamScore_Half = query[4].Split(':')[0].TryToInt32();
                game.IsOvertime = false;
                game.Remark = url;
                game.Season = Season;
                game.StartDateTime = Convert.ToDateTime(query[0]);
                game.Status = query[4] == "-:-" ? g1 : query[2] == "-:-" ? g2 : g3;
                team = teamlist.Where(a => a.Name == query[3]).FirstOrDefault();
                if (team == null)
                    return new F_Games();
                game.VisitingTeamId = team.Id;
                game.VisitingTeamScore_All = query[2].Split(':')[1].TryToInt32();
                game.VisitingTeamScore_Half = query[4].Split(':')[1].TryToInt32();
                game.GroupingId = Id;
                game.IsObtain = false;
                // gamesList.Add(game);
                return game;
            
        }
        
    }
}
