﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using FCS.Common;
using FCS.Crawler.Basketball;
using FCS.Crawler.ZCLotteryAgainst;
using FCS.Crawler.ZCLotteryGames;
using FCS.Crawler.ZCLotteryGrouping;
using FCS.Crawler.ZCLotteryIP;
using FCS.Crawler.ZCLotteryMatchs;
using FCS.Crawler.ZCLotteryScore;
using FCS.Crawler.ZCLotteryTeam;
using FCS.Crawler.ZCMatchRankingList;
using FCS.Interface;
using Quartz;

namespace FCS.Crawler
{
    public class Update_PlayerJob : CommonJob,IJob
    {
        public Update_PlayerJob()
        {
            logName = "Update_PlayerJob";
        }
        public void Execute(IJobExecutionContext context)
        {
            Config = CommonHelper.GetConfigFromDataMap(context.JobDetail.JobDataMap);
            Click();
        }
        public void Click()
        {
            ThreadPool.SetMaxThreads(200, 200);
            CommonHelper.LogBD("开始Update_PlayerJob", logName);
            new IPJob().GetIP();
            CommonHelper.LogBD("GetIP完成", logName);
            new FootBallTeamsJob().GetAll();
            CommonHelper.LogBD("FootBallTeamsJob完成", logName);
            new FootballPlayerJob().GetAll();
            CommonHelper.LogBD("FootballPlayerJob完成", logName);

            new GoalSingleDbListJob().Click();
            CommonHelper.LogBD("GoalSingleDbListJob完成", logName);
            new MakeBallListJob().Click();
            CommonHelper.LogBD("MakeBallListJob完成", logName);
            new RankingListJob().Click();
            CommonHelper.LogBD("RankingListJob完成", logName);
            new ShooterListJob().Click();
            CommonHelper.LogBD("ShooterListJob完成", logName);
            new UpperLlowerSingleDoubleJob().Click();
            CommonHelper.LogBD("UpperLlowerSingleDoubleJob完成", logName);

            while (true)
            {
                if (CommonHelper.ThreadsFinsh())
                    break;
            }
            CommonHelper.LogBD("Update_PlayerJob完成", logName);
        }
    }

}
