﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using FCS.Common;
using FCS.Crawler.ZCLotteryAgainst;
using FCS.Crawler.ZCLotteryAsianDish;
using FCS.Crawler.ZCLotteryGames;
using FCS.Crawler.ZCLotteryGrouping;
using FCS.Crawler.ZCLotteryIP;
using FCS.Crawler.ZCLotteryMatchs;
using FCS.Crawler.ZCLotteryScore;
using FCS.Crawler.ZCLotterySizeIndex;
using FCS.Crawler.ZCLotteryTeam;
using FCS.Interface;
using FCS.Models;
using Quartz;

namespace FCS.Crawler
{
    public class Update_RealTimeJobToDay10 : CommonJob, IJob
    {
        public Update_RealTimeJobToDay10()
        {
            logName = "Update_RealTimeJobToDay10";
        }
        public void Execute(IJobExecutionContext context)
        {
            Config = CommonHelper.GetConfigFromDataMap(context.JobDetail.JobDataMap);
            Click();
        }

        public void Click()
        {
            CommonHelper.LogBD("开始Update_RealTimeJobToDay10", logName);
            Trace.WriteLine("开始Update_RealTimeJobToDay10" + DateTime.Now);

            #region 从第二天开始到第十天的数据
            for (int j = 1; j < 10; j++)
            {
                CommonHelper.LogBD("开始Update_RealTimeJobToDay10的第几天 ****" + j + "****", logName);
                var querylist = services.Query<F_Games>("  and StartDateTime>'" + DateTime.Now.AddDays(1).ToString("yyyy-MM-dd") + "' and StartDateTime < '" + DateTime.Now.AddDays(10).AddHours(1).ToString("yyyy-MM-dd") + "'").Where(a => a.StartDateTime > Convert.ToDateTime(DateTime.Now.AddDays(j).ToShortDateString()) && a.StartDateTime < Convert.ToDateTime(DateTime.Now.AddDays(j + 1).ToShortDateString())).ToList();
                querylist = querylist.Where((x, i) => querylist.FindIndex(z => z.Id == x.Id) == i).ToList();//Lambda表达式去重
                int pagelist = querylist.Count % 100 == 0 ? querylist.Count / 100 : querylist.Count / 100 + 1;
                for (int i = 0; i < pagelist; i++)
                {
                    var query1 = querylist.Skip(i * 100).Take(100).ToList();
                    //list = query;
                    var task1 = new Task(() =>
                    {
                        new OddsJob().Click(query1);
                    });
                    task1.Start();
                    Task.WaitAll(task1);
                    CommonHelper.LogBD("欧赔结束", logName);
                    var task2 = new Task(() =>
                    {
                        new AsianDishJob().Click(query1);
                    });
                    task2.Start();
                    Task.WaitAll(task2);
                    CommonHelper.LogBD("亚盘结束", logName);
                    var task3 = new Task(() =>
                    {
                        new SizeIndexJob().Click(query1);
                    });
                    task3.Start();
                    Task.WaitAll(task3);
                    CommonHelper.LogBD("大小结束", logName);
                    //Task.WaitAll(task1, task2,task3);

                    List<string> listint = new List<string>();
                    foreach (var item in querylist)
                    {
                        listint.Add(item.Id);
                    }
                    if (listint.Count > 0)
                        services.Update<F_Games>(" and Id in ('" + string.Join("','", listint) + "')");
                }
            }

            #endregion


            CommonHelper.LogBD("获取完Update_RealTimeJobToDay10", logName);
            Trace.WriteLine("获取完Update_RealTimeJobToDay10" + DateTime.Now);
        }
    }

}
